SCRIPT_NAME = "collect_internal_linked.lua"
os.setlocale("C")

local RawBlock = pandoc.RawBlock
local parts = pandoc.MetaList({})

local visited = {}

return {
  { Link = function(link)
    -- early return for visited
    if visited[link.target] then return end
    visited[link.target] = true

    -- early return for external links
    if link.target:find("^https?%:%/%/") then return end
    if link.target:find("^mailto%:") then return end

    local fp, anchor = link.target:match("^(.+%.md)#?(.*)$")
    -- early return for non markdown files
    if not fp then return end

    local f = io.open(fp)
    -- early return for broken internal links
    if f == nil then return link.content else f:close() end -- @todo maybe log broken internal links

    local part_fp = fp:gsub("^(.+)%.md$", "public_html/%1.html.part")
    local f = assert(io.open(part_fp), "\n" ..
      "[ERROR] could not open " .. part_fp .. " for reading.")
    local rawblock = RawBlock(FORMAT, f:read("a")); f:close()
    parts:insert(rawblock)
  end },
  { Meta = function (meta)
    meta["parts"] = parts
    return meta
  end }
}
